<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="110px">
      <el-form-item :label="'举报人'+systemName+'号'" prop="usercode">
        <el-input
            v-model="queryParams.usercode"
            :placeholder="'请输入'+systemName+'号'"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item :label="'举报对象'+systemName+'号'" prop="reportUsercode">
        <el-input
            v-model="queryParams.reportUsercode"
            placeholder="请输入手机号"
            clearable
            @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="状态" prop="status">
        <el-select v-model="queryParams.status" placeholder="状态" clearable size="small">
          <el-option
              v-for="dict in reportStatusList"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
              @keyup.enter.native="handleQuery"
          />
        </el-select>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            icon="el-icon-delete"
            size="mini"
            :disabled="multiple"
            @click="handleDelete"
            v-hasPermi="['cai:report:remove']"
        >删除
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="reportList" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="举报页面" align="center" prop="type">
        <template v-slot="scope">
          <cai-dict-tag :options="reportTypeList" :value="scope.row.type"/>
        </template>
      </el-table-column>
      <el-table-column label="举报分类" align="center" prop="cateName"/>
      <el-table-column label="举报人" align="center">
        <el-table-column label="头像" align="center" prop="avatar">
          <template v-slot="scope">
            <image-avatar :src="scope.row.avatar"/>
          </template>
        </el-table-column>
        <el-table-column :label="systemName+'号'" align="center" prop="usercode"/>
      </el-table-column>
      <el-table-column label="举报对象" align="center">
        <el-table-column label="头像" align="center" prop="reportAvatar">
          <template v-slot="scope">
            <image-avatar :src="scope.row.reportAvatar"/>
          </template>
        </el-table-column>
        <el-table-column label="昵称" align="center" prop="reportNickname"/>
        <el-table-column :label="systemName+'号'" align="center" prop="reportUsercode"/>
        <el-table-column label="IM状态" align="center" prop="im" >
          <template v-slot="scope">
            <el-tag v-if="scope.row.reportEnableIm && scope.row.reportImSpeck" :disable-transitions="true" type="primary">正常</el-tag>
            <el-tag v-if="scope.row.reportEnableIm && !scope.row.reportImSpeck" :disable-transitions="true" type="warning">禁言</el-tag>
            <el-tag v-if="!scope.row.reportEnableIm && scope.row.reportImSpeck"  :disable-transitions="true" type="danger">封禁</el-tag>
            <el-tag v-if="!scope.row.reportEnableIm && !scope.row.reportImSpeck"  :disable-transitions="true" type="danger">封禁+禁言</el-tag>
          </template>
        </el-table-column>
      </el-table-column>
      <el-table-column label="举报内容" align="center" prop="content"/>
      <el-table-column label="状态" align="center" prop="status">
        <template v-slot="scope">
          <cai-dict-tag :options="reportStatusList" :value="scope.row.status"/>
        </template>
      </el-table-column>
      <el-table-column label="举报时间" align="center" prop="createTime" width="160"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="160">
        <template v-slot="scope">
          <el-button
              size="mini"
              type="text"
              @click="handleUserForbid(scope.row)"
              v-hasPermi="['cai:user:lock']"
          >封号
          </el-button>
          <el-button
              size="mini"
              type="text"
              v-if="scope.row.status === 0"
              @click="handleStatus(scope.row)"
              v-hasPermi="['cai:report:edit']"
          >处理
          </el-button>
          <el-button
              size="mini"
              type="text"
              @click="handleDelete(scope.row)"
              v-hasPermi="['cai:report:remove']"
          >删除
          </el-button>
          <el-dropdown size="mini" @command="(command) => handleCommand(command, scope.row)">
            <el-button size="mini" type="text" icon="el-icon-d-arrow-right">更多</el-button>
            <el-dropdown-menu slot="dropdown">
              <el-dropdown-item v-hasPermi="['cai:user:im']" v-if="scope.row.reportEnableIm" command="handleLockIm" icon="el-icon-lock"><span style="color: red">封禁IM</span></el-dropdown-item>
              <el-dropdown-item v-hasPermi="['cai:user:im']" v-if="!scope.row.reportEnableIm" command="handleUnlockIm" icon="el-icon-unlock"><span style="color: blue">解封IM</span></el-dropdown-item>
              <el-dropdown-item v-hasPermi="['cai:user:im']" v-if="scope.row.reportImSpeck" command="handleNoSpeckIm" icon="el-icon-lock"><span style="color: red">禁言</span></el-dropdown-item>
              <el-dropdown-item v-hasPermi="['cai:user:im']" v-if="!scope.row.reportImSpeck" command="handleEnSpeckIm" icon="el-icon-unlock"><span style="color: blue">解封禁言</span></el-dropdown-item>
            </el-dropdown-menu>
          </el-dropdown>
        </template>
      </el-table-column>
    </el-table>

    <pagination
        v-show="total>0"
        :total="total"
        :page.sync="queryParams.pageNum"
        :limit.sync="queryParams.pageSize"
        @pagination="getList"
    />

    <user-forbid-dialog v-if="userForbidVisible" ref="userForbid" @refreshDataList="getList" />
  </div>
</template>

<script>
import { delReport, listReport, updateReport } from '@/api/cai/report'
import { reportStatusList, reportTypeList } from '@/constant/statusMap'
import UserForbidDialog from "@/views/cai/user/user-forbid-dialog";
import {enSpeckIm, lockIm, noSpeckIm, unLockIm, userLogout} from "@/api/cai/user";

export default {
  name: 'Report',
  components: {
    UserForbidDialog
  },
  data() {
    return {
      reportTypeList, reportStatusList,
      systemName: process.env.VUE_APP_SYSTEM_HOME,
      userForbidVisible: false,
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 举报表格数据
      reportList: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        usercode: undefined,
        reportUsercode: undefined,
        status: 0
      }
    }
  },
  created() {
    this.getList()
  },
  methods: {
    /** 查询举报列表 */
    getList() {
      this.loading = true
      listReport(this.queryParams).then(response => {
        this.reportList = response.rows
        this.total = response.total
        this.loading = false
      })
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1
      this.getList()
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm('queryForm')
      this.handleQuery()
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset()
      this.open = true
      this.title = '添加举报'
    },
    /** 修改按钮操作 */
    handleStatus(row) {
      this.buttonLoading = true
      updateReport({
        id: row.id
      }).then(response => {
        this.$modal.msgSuccess('处理成功')
        this.open = false
        this.getList()
      }).finally(() => {
        this.buttonLoading = false
      })
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids
      this.$modal.confirm('是否确认删除举报编号为"' + ids + '"的数据项？').then(() => {
        this.loading = true
        return delReport(ids)
      }).then(() => {
        this.loading = false
        this.getList()
        this.$modal.msgSuccess('删除成功')
      }).catch(() => {
      }).finally(() => {
        this.loading = false
      })
    },
    handleUserForbid(row){
      this.userForbidVisible = true
      this.$nextTick(() => {
        this.$refs.userForbid.init(row.reportUid)
      })
    },
    handleLockIm(row){
      this.$modal.confirm('是否确认封禁用户"' + row.reportNickname + '"的IM？').then(() => {
        this.loading = true;
        return lockIm(row.reportUid);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleUnlockIm(row){
      this.$modal.confirm('是否确认解封用户"' + row.reportNickname + '"的IM？').then(() => {
        this.loading = true;
        return unLockIm(row.reportUid);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleNoSpeckIm(row){
      this.$modal.confirm('是否确认封禁用户"' + row.reportNickname + '"的IM聊天功能？').then(() => {
        this.loading = true;
        return noSpeckIm(row.reportUid);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleEnSpeckIm(row){
      this.$modal.confirm('是否确认解封用户"' + row.reportNickname + '"的IM聊天功能？').then(() => {
        this.loading = true;
        return enSpeckIm(row.reportUid);
      }).then(() => {
        this.loading = false;
        this.getList();
        this.$modal.msgSuccess("操作成功");
      }).catch(() => {
      }).finally(() => {
        this.loading = false;
      });
    },
    handleCommand(command, row) {
      switch (command) {
        case "handleLockIm":
          this.handleLockIm(row);
          break;
        case "handleUnlockIm":
          this.handleUnlockIm(row);
          break;
        case "handleNoSpeckIm":
          this.handleNoSpeckIm(row);
          break;
        case "handleEnSpeckIm":
          this.handleEnSpeckIm(row);
          break;
        default:
          break;
      }
    },
  }
}
</script>
